Index: /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 1)
@@ -1,12 +1,9 @@
 package geniusweb.protocol.session.saop;
 
-import java.util.Arrays;
 import java.util.Collections;
-import java.util.HashSet;
+import java.util.HashMap;
+import java.util.LinkedList;
 import java.util.List;
 import java.util.Map;
-
-import com.fasterxml.jackson.annotation.JsonCreator;
-import com.fasterxml.jackson.annotation.JsonProperty;
 
 import geniusweb.actions.Accept;
@@ -15,11 +12,12 @@
 import geniusweb.actions.Offer;
 import geniusweb.actions.PartyId;
-import geniusweb.inform.Agreements;
 import geniusweb.issuevalue.Bid;
 import geniusweb.progress.Progress;
 import geniusweb.progress.ProgressRounds;
 import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.partyconnection.ConnectionWithParties;
+import geniusweb.protocol.partyconnection.ConnectionWithParty;
 import geniusweb.protocol.session.DefaultSessionState;
-import geniusweb.protocol.session.SessionResult;
+import geniusweb.protocol.session.SessionSettings;
 import geniusweb.references.PartyWithProfile;
 
@@ -27,59 +25,120 @@
  * Immutable.
  */
-public class SAOPState extends DefaultSessionState<SAOPState, SAOPSettings> {
-
-	/**
-	 * 
-	 * @param actions       the actions done by the parties
-	 * @param connections   the existing party connections. If null, default
+public class SAOPState extends DefaultSessionState {
+
+	/**
+	 * 
+	 * @param actions
+	 * @param conns         the existing party connections. we assume ownership
+	 *                      of this so it should not be modified although
+	 *                      connections may of course break. If null, default
 	 *                      empty list is used. Can be less than 2 parties in
-	 *                      the first phases of the setup or after parties
-	 *                      disconnected.
+	 *                      the first phases of the setup.
 	 * @param progress      the {@link Progress} line. can be null
 	 * @param settings      the {@link SAOPSettings}
 	 * @param partyprofiles map with the {@link PartyWithProfile} for connected
 	 *                      parties. null is equivalent to an empty map.
-	 * @param error         the {@link ProtocolException}, or null if none
+	 * @param e             the {@link ProtocolException}, or null if none
 	 *                      occurred.
 	 */
-	@JsonCreator
-	public SAOPState(@JsonProperty("actions") List<Action> actions,
-			@JsonProperty("connections") List<PartyId> connections,
-			@JsonProperty("progress") Progress progress,
-			@JsonProperty("settings") SAOPSettings settings,
-			@JsonProperty("partyprofiles") Map<PartyId, PartyWithProfile> partyprofiles,
-			@JsonProperty("error") ProtocolException error) {
-		super(actions, connections, progress, settings, partyprofiles, error);
+	public SAOPState(List<Action> actions, ConnectionWithParties conns,
+			Progress progress, SessionSettings settings,
+			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
+		super(actions, conns, progress, settings, partyprofiles, e);
+	}
+
+	/**
+	 * Creates the initial state from the given settings and progress=null
+	 * 
+	 * @param settings the {@link SAOPSettings}
+	 */
+	public SAOPState(SAOPSettings settings) {
+		this(Collections.emptyList(),
+				new ConnectionWithParties(Collections.emptyList()), null,
+				settings, null, null);
+
+	}
+
+	/**
+	 * @param actor         the actor that did this action. Can be used to check
+	 *                      if action is valid. NOTICE caller has to make sure
+	 *                      the current state is not final.
+	 * @param action        the action that was proposed by actor.
+	 * @param currentTimeMs the current time in ms since 1970, see
+	 *                      {@link System#currentTimeMillis()}
+	 * @return new SessionState with the action added as last action.
+	 */
+	public SAOPState with(PartyId actor, Action action) {
+		try {
+			return with1(actor, action);
+		} catch (ProtocolException e) {
+			List<Action> newactions = new LinkedList<>(getActions());
+			newactions.add(action);
+			return new SAOPState(newactions, getConnections(), getProgress(),
+					getSettings(), getPartyProfiles(), e);
+		}
+	}
+
+	/**
+	 * 
+	 * @param connection   the new {@link ConnectionWithParty}
+	 * @param partyprofile the {@link PartyWithProfile} that is associated with
+	 *                     this state
+	 * @return new SessionState with the new connection added. This call ignores
+	 *         the progress (does not check isFinal) because SAOP uses this
+	 *         during the setup where the deadline is not yet relevant. The
+	 *         connection should be informed about the partyprofile but the
+	 *         state currently indicate if that already happened or not.
+	 */
+	public SAOPState with(ConnectionWithParty connection,
+			PartyWithProfile partyprofile) {
+		// Only called from the SAOP initialization phase.
+		ConnectionWithParties newconns = getConnections().with(connection);
+		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
+				getPartyProfiles());
+		newprofiles.put(connection.getParty(), partyprofile);
+		return new SAOPState(getActions(), newconns, getProgress(),
+				getSettings(), newprofiles, null);
+	}
+
+	/**
+	 * 
+	 * @param e             the error that occured
+	 * @param currentTimeMs the current time in ms since 1970, see
+	 *                      {@link System#currentTimeMillis()}
+	 * @return a new state with the error set.
+	 */
+	public SAOPState with(ProtocolException e) {
+		return new SAOPState(getActions(), getConnections(), getProgress(),
+				getSettings(), getPartyProfiles(), e);
+	}
+
+	/**
+	 * Sets the progress for this session. Can be set only if progress=null.
+	 * 
+	 * @param newprogress the new progress
+	 * @return new SAOPState with the progress set
+	 */
+	public SAOPState with(Progress newprogress) {
+		if (newprogress == null) {
+			throw new IllegalArgumentException("newprogress must be not null");
+		}
+		if (getProgress() != null) {
+			return this;
+		}
+		return new SAOPState(getActions(), getConnections(), newprogress,
+				getSettings(), getPartyProfiles(), getError());
 	}
 
 	@Override
-	public SAOPState with(List<Action> actions, List<PartyId> conns,
-			Progress progr, SAOPSettings settings,
-			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
-		return new SAOPState(actions, conns, progr, settings, partyprofiles, e);
-	}
-
-	/**
-	 * Creates the initial state from the given settings and progress=null
-	 * 
-	 * @param settings the {@link SAOPSettings}
-	 */
-	public SAOPState(SAOPSettings settings) {
-		this(Collections.emptyList(), Collections.emptyList(), null, settings,
-				null, null);
-
-	}
-
-	@Override
-	public Agreements getAgreements() {
-		Agreements agree = new Agreements();
+	public Bid getAgreement() {
 		List<Action> acts = getActions();
 		int nparticipants = getConnections().size();
 		if (nparticipants < 2 || acts.size() < nparticipants) {
-			return agree;
+			return null;
 		}
 		Action offer = acts.get(acts.size() - nparticipants);
 		if (!(offer instanceof Offer))
-			return agree;
+			return null;
 		Bid bid = ((Offer) offer).getBid();
 
@@ -88,16 +147,5 @@
 				.allMatch(act -> act instanceof Accept
 						&& bid.equals(((Accept) act).getBid()));
-		if (allaccept)
-			agree = agree
-					.with(new Agreements(bid, new HashSet<>(getParties())));
-		return agree;
-	}
-
-	/**
-	 * 
-	 * @return all currently connected parties.
-	 */
-	public List<PartyId> getParties() {
-		return getConnections();
+		return allaccept ? bid : null;
 	}
 
@@ -105,39 +153,12 @@
 	public boolean isFinal(long currentTimeMs) {
 		List<Action> acts = getActions();
-		return super.isFinal(currentTimeMs)
-				|| !getAgreements().getMap().isEmpty() || (!acts.isEmpty()
+		return super.isFinal(currentTimeMs) || getAgreement() != null
+				|| (!acts.isEmpty()
 						&& acts.get(acts.size() - 1) instanceof EndNegotiation);
 	}
 
 	@Override
-	public SAOPState with(PartyId actor, Action action) {
-		return super.with(actor, action).with(advanceProgress());
-	}
-
-	@Override
-	public String checkAction(PartyId actor, Action action) {
-		String msg = super.checkAction(actor, action);
-		if (msg != null)
-			return msg;
-
-		if (!actor.equals(getNextActor()))
-			return "Party does not have the turn ";
-
-		// check protocol is followed for specific actions
-		if (action instanceof Accept) {
-			Bid bid = getLastBid();
-			if (bid == null)
-				return "Accept without a recent offer";
-
-			if (!bid.equals(((Accept) action).getBid()))
-				return "Party accepts a bid differing from the last offer ="
-						+ bid + ", action=" + action + ")";
-			return null;
-		} else if (action instanceof Offer) {
-			return null;
-		} else if (action instanceof EndNegotiation) {
-			return null;
-		}
-		return "Action " + action + " is not allowed in SAOP";
+	public SAOPSettings getSettings() {
+		return (SAOPSettings) super.getSettings();
 	}
 
@@ -161,19 +182,70 @@
 	}
 
+	private SAOPState with1(PartyId actor, Action action)
+			throws ProtocolException {
+
+		if (actor == null) { // this is a bug
+			throw new IllegalArgumentException("actor must not be null");
+		}
+		if (!actor.equals(getNextActor())) {
+			throw new ProtocolException("actor does not have the turn ",
+					actor.getName());
+
+		}
+		if (action == null) {
+			throw new ProtocolException("action is null", actor.getName());
+		}
+		if (!actor.equals(action.getActor())) {
+			throw new ProtocolException(
+					"act contains wrong credentials: " + action,
+					actor.getName());
+		}
+
+		// check protocol is followed for specific actions
+		if (action instanceof Accept) {
+			Bid bid = getLastBid();
+			if (bid == null) {
+				throw new ProtocolException("Accept without a recent offer",
+						actor.getName());
+			}
+			if (!bid.equals(((Accept) action).getBid())) {
+				throw new ProtocolException(
+						"Accepts a bid that was not offered (last offer =" + bid
+								+ ", action=" + action + ")",
+						actor.getName());
+			}
+		} else if (action instanceof Offer) {
+			// offer is always fine. We don't check if bid is actually in domain
+			// or complete etc. We would need domain for that
+		} else if (action instanceof EndNegotiation) {
+			// just act, we will get into the final state then.
+		} else {
+			throw new ProtocolException(
+					"Action " + action + " is not allowed in SAOP",
+					actor.getName());
+		}
+
+		List<Action> newactions = new LinkedList<>(getActions());
+		newactions.add(action);
+		return new SAOPState(newactions, getConnections(), advanceProgress(),
+				getSettings(), getPartyProfiles(), null);
+	}
+
 	/**
 	 * 
 	 * @return the next actor in the current state. Assumes 1 action per actor
-	 *         every time. NOTE if party disconnects this would jump wildly but
-	 *         nego stops then anyway
+	 *         every time.
 	 */
 	protected PartyId getNextActor() {
 		return getConnections()
-				.get(getActions().size() % getConnections().size());
-	}
-
-	/**
+				.get(getActions().size() % getConnections().size()).getParty();
+	}
+
+	/**
+	 * 
+	 * @param progress
 	 * @return new progress state
 	 */
-	public Progress advanceProgress() {
+	private Progress advanceProgress() {
 		Progress newprogress = getProgress();
 		if (newprogress instanceof ProgressRounds && isLastActor()) {
@@ -191,9 +263,3 @@
 	}
 
-	@Override
-	public List<SessionResult> getResults() {
-		return Arrays.asList(new SessionResult(getPartyProfiles(),
-				getAgreements(), Collections.emptyMap(), getError()));
-	}
-
 }
Index: /protocol/src/main/java/geniusweb/protocol/tournament/TournamentSettings.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/TournamentSettings.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/TournamentSettings.java	(revision 1)
@@ -5,5 +5,4 @@
 import geniusweb.protocol.NegoSettings;
 import geniusweb.protocol.tournament.allpermutations.AllPermutationsSettings;
-import geniusweb.protocol.tournament.allpermutationslearn.AllPermutationsLearnSettings;
 import tudelft.utilities.logging.Reporter;
 
@@ -11,6 +10,5 @@
  * Interface for tournament settings
  */
-@JsonSubTypes({ @JsonSubTypes.Type(value = AllPermutationsSettings.class),
-		@JsonSubTypes.Type(value = AllPermutationsLearnSettings.class) })
+@JsonSubTypes({ @JsonSubTypes.Type(value = AllPermutationsSettings.class) })
 public interface TournamentSettings extends NegoSettings {
 	@Override
Index: /protocol/src/main/java/geniusweb/protocol/tournament/TournamentState.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/TournamentState.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/TournamentState.java	(revision 1)
@@ -3,20 +3,12 @@
 import com.fasterxml.jackson.annotation.JsonAutoDetect;
 import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
-import com.fasterxml.jackson.annotation.JsonSubTypes;
-import com.fasterxml.jackson.annotation.JsonSubTypes.Type;
 
 import geniusweb.protocol.NegoState;
-import geniusweb.protocol.tournament.allpermutations.AllPermutationsState;
-import geniusweb.protocol.tournament.allpermutationslearn.AllPermutationsLearnState;
 
 /**
- * The current state of the tournament. Must be implement Json serialization so
- * that it can be used to log the state. State must contain all information to
- * determine the relevant info of the negotiation. It may also be used to
- * restart the nego if a crash occurs.
+ * The current state of the tournament. Must be serializabl;e so that it can be
+ * restarted if a crash occurs.
  */
 @JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
-@JsonSubTypes({ @Type(value = AllPermutationsState.class),
-		@Type(value = AllPermutationsLearnState.class) })
 public interface TournamentState extends NegoState {
 
Index: /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java
===================================================================
--- /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 53)
+++ /protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsProtocol.java	(revision 1)
@@ -1,5 +1,4 @@
 package geniusweb.protocol.tournament.allpermutations;
 
-import java.util.List;
 import java.util.logging.Level;
 
@@ -7,7 +6,7 @@
 import geniusweb.events.TournamentStarted;
 import geniusweb.protocol.CurrentNegoState;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.SessionResult;
+import geniusweb.protocol.partyconnection.ConnectionWithPartyFactory;
 import geniusweb.protocol.session.SessionProtocol;
-import geniusweb.protocol.session.SessionResult;
 import geniusweb.protocol.session.SessionSettings;
 import geniusweb.protocol.session.SessionState;
@@ -30,10 +29,10 @@
 	private final transient Reporter log;
 
-	private ProtocolToPartyConnFactory connectionFactory; // FINAL
+	private ConnectionWithPartyFactory connectionFactory; // FINAL
 	private AllPermutationsState state; // MUTABLE
 
 	/**
 	 * 
-	 * @param state  the {@link AllPermutationsState}
+	 * @param state
 	 * @param logger used for all logging, about the tournament, and the created
 	 *               the session and protocols.
@@ -46,7 +45,7 @@
 
 	@Override
-	public void start(ProtocolToPartyConnFactory connectionfactory) {
+	public void start(ConnectionWithPartyFactory connectionfactory) {
 		this.connectionFactory = connectionfactory;
-		notifyListeners(new TournamentStarted(state.getSize().longValue()));
+		notifyChange(new TournamentStarted(state.getSize().longValue()));
 		startNextSession();
 	}
@@ -82,7 +81,9 @@
 			long now = System.currentTimeMillis();
 			if (sessionstate.isFinal(now)) {
-				List<SessionResult> results = sessionstate.getResults();
-				state = state.with(results);
-				notifyListeners(new CurrentNegoState(state));
+				SessionResult result = new SessionResult(
+						sessionstate.getSettings().getParticipants(),
+						sessionstate.getAgreement(), sessionstate.getError());
+				state = state.with(result);
+				notifyChange(new CurrentNegoState(state));
 				if (!state.isFinal(now)) {
 					startNextSession();
